/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controlers;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.criteria.CriteriaQuery;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Ondrej Ritomský
 */
@Entity
@Table(name = "KATEGORIA")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Kategoria.findAll", query = "SELECT k FROM Kategoria k"),
    @NamedQuery(name = "Kategoria.findById", query = "SELECT k FROM Kategoria k WHERE k.id = :id"),
    @NamedQuery(name = "Kategoria.findByLabel", query = "SELECT k FROM Kategoria k WHERE k.label = :label")})
public class Kategoria implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "ID")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 24)
    @Column(name = "LABEL")
    private String label;
    @JoinTable(name = "HIERARCHIAKATEGORII", joinColumns = {
        @JoinColumn(name = "ID_NADKATEGORIA", referencedColumnName = "ID")}, inverseJoinColumns = {
        @JoinColumn(name = "ID_PODKATEGORIA", referencedColumnName = "ID")})
    @ManyToMany
    private Collection<Kategoria> kategoriaCollection; // toto je pod
    
    @ManyToMany(mappedBy = "kategoriaCollection", cascade = CascadeType.PERSIST)
    private Collection<Kategoria> kategoriaCollection1; // toto je nad 
    
    @JoinTable(name = "KATEGORIA_ZAZNAM", joinColumns = {
        @JoinColumn(name = "ID_KATEGORIA", updatable = true, referencedColumnName = "ID")}, inverseJoinColumns = {
        @JoinColumn(name = "ID_ZAZNAM", updatable = true,  referencedColumnName = "ID")})
    @ManyToMany
    private Collection<Zaznam> zaznamCollection;

    public Kategoria() {
    }

    
    public Kategoria(Integer id) {
        this.id = id;
    }

    public Kategoria(Integer id, String label) {
        this.id = id;
        this.label = label;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    @XmlTransient
    public Collection<Kategoria> getKategoriaCollection() {
        return kategoriaCollection;
    }

    public void setKategoriaCollection(Collection<Kategoria> kategoriaCollection) {
        this.kategoriaCollection = kategoriaCollection;
    }

    @XmlTransient
    public Collection<Kategoria> getKategoriaCollection1() {
        return kategoriaCollection1;
    }

    public void setKategoriaCollection1(Collection<Kategoria> kategoriaCollection1) {
        this.kategoriaCollection1 = kategoriaCollection1;
    }

    @XmlTransient
    public Collection<Zaznam> getZaznamCollection() {
        return zaznamCollection;
    }

    public void setZaznamCollection(Collection<Zaznam> zaznamCollection) {
        this.zaznamCollection = zaznamCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Kategoria)) {
            return false;
        }
        Kategoria other = (Kategoria) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "Kategoria[ id=" + id + " ] label = "+label ;
    }

}
