/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controlers;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Ondrej Ritomský
 */
@Entity
@Table(name = "ZAZNAM")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Zaznam.findAll", query = "SELECT z FROM Zaznam z"),
    @NamedQuery(name = "Zaznam.findById", query = "SELECT z FROM Zaznam z WHERE z.id = :id"),
    @NamedQuery(name = "Zaznam.findByLabel", query = "SELECT z FROM Zaznam z WHERE z.label = :label")})
public class Zaznam implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "ID")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 24)
    @Column(name = "LABEL")
    private String label;
    @ManyToMany(mappedBy = "zaznamCollection", cascade = CascadeType.PERSIST)
    private Collection<Kategoria> kategoriaCollection;

    public Zaznam() {
    }

    public Zaznam(Integer id) {
        this.id = id;
    }

    public Zaznam(Integer id, String label) {
        this.id = id;
        this.label = label;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    @XmlTransient
    public Collection<Kategoria> getKategoriaCollection() {
        return kategoriaCollection;
    }

    public void setKategoriaCollection(Collection<Kategoria> kategoriaCollection) {
        this.kategoriaCollection = kategoriaCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Zaznam)) {
            return false;
        }
        Zaznam other = (Zaznam) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "controlers.Zaznam[ id=" + id + " ]";
    }
    
}
